--
-- Beispiel "Zeichenketten selbstgemacht"
-- 
module MyString where

data MyString = Empty 
              | Cons Char MyString    
              deriving (Show, Eq)

-- Laenge einer Zeichenkette
len :: MyString-> Int
len Empty        = 0
len (Cons c str) = 1+ len str      

-- Verkettung zweier Zeichenketten
cat :: MyString-> MyString-> MyString
cat Empty t      = t
cat (Cons c s) t = Cons c (cat s t)

-- Zeichenkette umkehren
rev :: MyString-> MyString
rev Empty      = Empty
rev (Cons c t) = cat (rev t) (Cons c Empty)

-- Die ersten n Zeichen der Zeichenkette
-- Voraussetzung: n >= 0
takeN :: Int-> MyString-> MyString
takeN n Empty = Empty
takeN n (Cons c s) = if n == 0 then Empty
                     else Cons c (takeN (n-1) s)

-- Die letzten n Zeichen der Zeichenkette
-- Voraussetzung: n >= 0
dropN :: Int-> MyString-> MyString
dropN n Empty      = Empty
dropN n (Cons c s) = if n == 0 then Cons c s
                     else dropN (n- 1) s


